! attention : les fichiers de zahir sont en big endian!
! -byteswapio
Program density_proj
  !     computes the projected density field from PM_Para_Q (HORIZON simus)
  ! projection is along the z axis
  Implicit none
  Integer, parameter:: nproc=32
  Integer:: nz,npart,nint
  Integer:: npart_loc
  integer::ix,iy,ixp1,iyp1
  Character(len=32):: filein,filename
  Real(8),dimension(:,:),allocatable ::map
  Real(4),dimension(:,:),allocatable ::x_loc
  Real(4):: ekin, egrav, egint,boxlen,aexp
  Real(4):: omega,omega0,omega_lambda,fk0,h0,hub,omega_b
  Real(4):: alpha,astart,tempx,tempy,tempz
  real(KIND=8)::ddx,ddy,dex,dey,dx,dy
  Integer:: istep,i,j,k,l

  write(*,*) 'Enter root filename for input (lsf_p1_01)'
  read(*,*) filein
  Write(filename,'(a,".",i4.4)') trim(filein),0
  Open(10,file=trim(filename),form='unformatted')
  Rewind 10

  Read(10) nz,npart,boxlen,aexp, &
       &     omega,omega0,omega_lambda, &
       &     omega_b,fk0,h0,hub, &
       &     alpha,astart,istep
  Read(10) ekin,egrav,egint

  close(10)

  Write(*,*) 'nz =',nz
  Write(*,*) 'npart= ',npart
  Write(*,*) 'boxlen =',boxlen
  Write(*,*) 'a= ',aexp
  Write(*,*)  'Omega_m= ',omega0
  Write(*,*) 'Omega_vac= ',omega_lambda,' Omega_b=  ',omega_b
  Write(*,*) 'H0= ',h0
  Write(*,*) 'astart= ',astart
  
  nint=nz

  allocate(map(0:nint,0:nint))
  map=0.d0
  npart_loc = npart/nproc
  write(*,*) 'npart_loc=',npart_loc

  write(*,*)'There are ',npart,' DM particles'
  write(*,*)'Reading positions ...'
  allocate(x_loc(3,npart_loc))

  do k=1,nproc
     Write(filename,'(a,".",i4.4)') trim(filein),k-1
     write(*,*) filename
     Open(10,file=trim(filename),form='unformatted')
     Rewind 10

     Read(10) nz,npart,boxlen,aexp, &
          &     omega,omega0,omega_lambda, &
          &     omega_b,fk0,h0,hub, &
          &     alpha,astart,istep
     Read(10) ekin,egrav,egint

     Read(10) ((x_loc(j,i),j=1,3),i=1,npart_loc)
!     ! shift of half the box length in the x-direction
    do l=1,npart_loc
        x_loc(1,l)=x_loc(1,l)+0.5
        if(x_loc(1,l).gt.1.) then
           x_loc(1,l)=x_loc(1,l)-1.
        endif
     enddo

     do i=1,npart_loc
        ddx=real(x_loc(1,i),8)*dfloat(nint) 
        ddy=real(x_loc(2,i),8)*dfloat(nint) 
        ix=aint(ddx)
        iy=aint(ddy)
        ddx=ddx-real(ix)
        ddy=ddy-real(iy)
        dex=1.0-ddx
        dey=1.0-ddy
        if(ix<0)ix=ix+nint
        if(ix>=nint)ix=ix-nint
        if(iy<0)iy=iy+nint
        if(iy>=nint)iy=iy-nint
        ixp1=ix+1
        iyp1=iy+1
        if(ixp1<0)ixp1=ixp1+nint
        if(ixp1>=nint)ixp1=ixp1-nint
        if(iyp1<0)iyp1=iyp1+nint
        if(iyp1>=nint)iyp1=iyp1-nint
        map(ix  ,iy  )=map(ix  ,iy  )+dex*dey
        map(ix  ,iyp1)=map(ix  ,iyp1)+dex*ddy
        map(ixp1,iy  )=map(ixp1,iy  )+ddx*dey
        map(ixp1,iyp1)=map(ixp1,iyp1)+ddx*ddy
     end do
     close(10)
  enddo

  open(20,file='proj_'//trim(filein))

  Do ix=0,nint-1
     do iy=0,nint-1
        write(20,*) ix,iy,map(ix,iy)
     enddo
     write(20,*)
  enddo
  write(20,*)
  close(20)
  
  open(10,file='pm2map'//trim(filein),form='unformatted')
  
     write(10)nint,nint
     write(10)real(map(0:nint-1,0:nint-1))
     close(10)
  deallocate (map,x_loc)
end program density_proj

